/**
 * @file CFootyViewNX
 * @brief ̃t@CGUI`揈S܂B
 * @author Shinji Watanabe
 * @version 1.0
 */

#include "FootyView.h"
#include "StaticStack.h"

#ifndef UNDER_CE
#	pragma comment (lib, "Msimg32.lib")
#endif	/*not defined UNDER_CE*/

/*-------------------------------------------------------------------
CFootyView::MoveWin
傫̕ύXBbRefreshfalsêƂAPɗ̈vẐ݂s
-------------------------------------------------------------------*/
bool CFootyView::MoveWin(int x,int y,int nWidth,int nHeight,bool bRefresh){
	/*錾*/
	int nDrawAreaWidth;			/*`̈敝*/
	int nDrawAreaHeight;		/*`̈捂*/

	/*񂩂烁oϐݒ肷*/
	m_x = x;					/*xW*/
	m_y = y;					/*yW*/
	m_nHeight = nHeight;		/**/
	m_nWidth = nWidth;			/**/
	
	/*\ł錅*/
	nDrawAreaWidth = nWidth - m_nLineCountWidth - GetSystemMetrics(SM_CXVSCROLL);
	if (nDrawAreaWidth > 0)
		m_nVisibleColumns = nDrawAreaWidth / (m_pFonts->GetWidth() + m_nWidthMargin);
	else
		m_nVisibleColumns = 0;

	/*\łs*/
	if (m_nVisibleColumns <= m_pDocuments->GetLapelColumn())/*XN[\Ă*/
		nDrawAreaHeight = nHeight - m_nRulerHeight - GetSystemMetrics(SM_CYVSCROLL);
	else													/*XN[\ĂȂ*/
		nDrawAreaHeight = nHeight - m_nRulerHeight;

	if (nDrawAreaHeight > 0)
		m_nVisibleLines = nDrawAreaHeight / (m_pFonts->GetHeight() + m_nHeightMargin);
	else
		m_nVisibleLines = 0;

	/*ړčĕ`揈*/
	if (bRefresh){
		m_cDoubleBuffering.ChangeSize(m_hWnd,nWidth,nHeight);
		MoveWindow(m_hWnd,x,y,m_nWidth,m_nHeight,true);	/*EBhËړ*/
		Refresh(false);
	}
	return true;
}

/*-------------------------------------------------------------------
CFootyView::SetVisible
\E\̐ݒ
-------------------------------------------------------------------*/
void CFootyView::SetVisible(bool bVisible){
	ShowWindow(m_hWnd,bVisible ? SW_SHOWNORMAL : SW_HIDE);
	m_bVisible = bVisible;
}

/*-------------------------------------------------------------------
CFootyView::SetLineWidth
sԍ\ݒ肷
-------------------------------------------------------------------*/
void CFootyView::SetLineWidth(int nWidth){
	if (nWidth < 0)
		m_nLineCountWidth = LINEWIDTH_DEFAULT;
	else
		m_nLineCountWidth = nWidth;
	MoveWin(m_x,m_y,m_nWidth,m_nHeight,false);
}

/*-------------------------------------------------------------------
CFootyView::SetRulerHeight
[[w肷
-------------------------------------------------------------------*/
void CFootyView::SetRulerHeight(int nHeight){
	if (nHeight < 0)
		m_nRulerHeight = RULERHEIGHT_DEFAULT;
	else
		m_nRulerHeight = nHeight;
	MoveWin(m_x,m_y,m_nWidth,m_nHeight,false);
}

/*-------------------------------------------------------------------
CFootyView::SetMarginHeight
}[Ww肷
-------------------------------------------------------------------*/
void CFootyView::SetMarginHeight(int nHeight){
	if (nHeight < 0) {
		m_nHeightMargin = 0 ;
		m_nLineCountMargin = 0;
	} else {
		m_nHeightMargin = nHeight;
		m_nLineCountMargin = nHeight;
	}
	MoveWin(m_x,m_y,m_nWidth,m_nHeight,false);
}

//-----------------------------------------------------------------------------
/**
 * @brief EBhE̋ĕ`揈ł
 * @param	bSendOther	[in] قȂr[ɑ΂Ă𑗐M邩ǂI܂
 */
bool CFootyView::Refresh(bool bSendOther)
{
	if (m_bVisible)						// ĕ`͕\ĂƂ̂
	{
		FOOTY2_PRINTF( L"ItbVI %d\n", m_nFootyID );

		// G
		CaretMove();
		SetBars();

		/*// F by Tetr@pod
		for (LinePt Line = m_pDocuments->GetTopLine(); Line != m_pDocuments->GetLastLine(); Line++) {
			m_pDocuments->SetLineInfo2(Line);
		}*/
		if (DrawAllUserFuncs) {
			for (LinePt Line = m_pDocuments->GetTopLine(); Line != m_pDocuments->GetLastLine(); ++Line) {
				m_pDocuments->FlushString2(Line);
				Line->SetEmphasisChached(false);
			}
			DrawAllUserFuncs = false;
			IsUFUpdateTiming = true;
		}

		// ĕ`揈
		HDC hDC = GetDC(m_hWnd);		// foCXReLXg擾
		FOOTY2_PRINTF( L"GetDC %d\n", m_nFootyID );
		if ( !hDC )
		{
			FOOTY2_PRINTF( L"But failed...\n", m_nFootyID );
			return false;
		}

		RECT rc;
		GetClientRect( m_hWnd, &rc );

		//FOOTY2_PRINTF( L"RECT %d,%d,%d,%d \n", rc.left, rc.top, rc.right, rc.bottom );
		//FOOTY2_PRINTF( L"`JnI\n");
		if (!Refresh(hDC,&rc))
		{
			ReleaseDC( m_hWnd, hDC );
			FOOTY2_PRINTF( L"ReleaseDC %d\n", m_nFootyID );
			return false;
		}
		//FOOTY2_PRINTF( L"`II\n");
		ReleaseDC(m_hWnd,hDC);			// foCXReLXg
		FOOTY2_PRINTF( L"ReleaseDC %d\n", m_nFootyID );

		// ̃r[֑M
		if (bSendOther)
		{
			for ( int i = 0; i < 4; i++ )
			{
				if (i != m_nViewID)
					m_pView[i].Refresh(false);
			}
		}
	}
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽfoCXReLXgւ̕`揈
 * @param hDC `foCXReLXg
 * @param rc ``
 */
bool CFootyView::Refresh(HDC hDC,const RECT *rc){
	// 錾
	int yNowPos;									//!< ݕ`撆yWʒu
	CEthicLine cNowLine;							//!< ݕ`撆̍s\
	LineSize nLines = m_pDocuments->GetLineNum();	//!< ҏW̕Ɋ܂܂s̑
	SelOldInfo stOldInfo;							//!< Ï攽]̂߂̋foCXReLXg
	HDC hDcBuffer = m_cDoubleBuffering.GetDC();

	// 
	m_cCaret.Hide();
	DrawRectangle(hDcBuffer,0,0,rc->right,rc->bottom,m_pStatus->m_clBackGround);
	m_ImgCtr->Draw(hDcBuffer, 0, 0, rc->right, rc->bottom, m_cDoubleBuffering.GetWidth(), m_cDoubleBuffering.GetHeight() );

	SetBkMode(hDcBuffer,TRANSPARENT);

	// ݂̕\ʒu烌_OĂ
	cNowLine = *m_pDocuments->GetFirstVisible(m_nViewID);
	yNowPos = m_nRulerHeight - (int)(cNowLine.GetEthicNum() *
		(m_nHeightMargin + m_pFonts->GetHeight()));

	forever
	{
		// _O
		RendLine(hDcBuffer,cNowLine.GetLinePointer(),
				 yNowPos,cNowLine.GetLineNum() + 1 == nLines);
		// yWύX
		yNowPos += (int)((m_nHeightMargin + m_pFonts->GetHeight()) *
			(cNowLine.GetLinePointer()->GetEthicLine()));
		if (yNowPos >= rc->bottom)break;
		// ̍s
		if (!cNowLine.MoveRealNext(m_pDocuments->GetLineList(),1))
			break;
	}
	// Ï̔]
	if (m_pDocuments->IsSelecting()){
		// ̏
		cNowLine = *m_pDocuments->GetFirstVisible(m_nViewID);
		yNowPos = m_nRulerHeight - (int)(cNowLine.GetEthicNum() *
			(m_nHeightMargin + m_pFonts->GetHeight()));
		// [v̊Jn
		InitDcForSelect(hDcBuffer,&stOldInfo);
		forever{
			// Ï̔]
			RendSelected(hDcBuffer,&cNowLine,yNowPos);						 
			// WύX
			yNowPos += (int)((m_nHeightMargin + m_pFonts->GetHeight()) *
				cNowLine.GetLinePointer()->GetEthicLine());
			if (yNowPos >= rc->bottom)break;
			// ̍s
			if (!cNowLine.MoveRealNext(m_pDocuments->GetLineList(),1))
				break;
		}
		ReleaseDcForSelect(hDcBuffer,&stOldInfo);
	}

	// ̂قtp[c`
	RendLineCount(hDcBuffer,rc);
	RendRuler(hDcBuffer,rc);
	RendBorderLine(hDcBuffer,rc);

	// [LOT[tBXRs[
	BitBlt(hDC,0,0,m_nWidth,m_nHeight,hDcBuffer,0,0,SRCCOPY);
	m_cDoubleBuffering.SetRendInfo(m_pDocuments->GetFirstVisible(m_nViewID));

	// LbgA_[C͍ŌɈ
	RendUnderLine(hDC,rc);
	// I
	m_cCaret.Show();

	return true;
}

//-----------------------------------------------------------------------------
/** 
 * @brief Lbgꂽ̂ƂɌĂяoĕ`惋[`łB
 * @return ƂtrueAsƂfalse
 * @note ̃r[͍ĕ`悵܂B
 */
bool CFootyView::CaretRefresh()
{
	if (m_bVisible)					// ĕ`͕\ĂƂ̂
	{
		if (!m_cDoubleBuffering.IsRendered())
		{
			return Refresh(false);
		}
		else
		{
			// G
			CaretMove();
			
			// 錾
			HDC hDC;
			HDC hDcBuffer = m_cDoubleBuffering.GetDC();
			RECT rc;
			
			// 
			hDC = GetDC(m_hWnd);		// foCXReLXg擾
			if (!hDC)return false;
			FOOTY2_PRINTF( L"GetDC %d\n", m_nFootyID );
			GetClientRect( m_hWnd,&rc );// `GA擾
			m_cCaret.Hide();			// Lbg\
			
			// `Jn
			RendLineCount(hDcBuffer,&rc);
			RendRuler(hDcBuffer,&rc);
			RendBorderLine(hDcBuffer,&rc);
			BitBlt(hDC,0,0,m_nWidth,m_nHeight,hDcBuffer,0,0,SRCCOPY);
			RendUnderLine(hDC,&rc);
			
			// foCXReLXg
			m_cCaret.Show();			// Lbg\
			ReleaseDC(m_hWnd,hDC);
			FOOTY2_PRINTF( L"ReleaseDC %d\n", m_nFootyID );
		}
	}
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief ㉺XN[ꂽƂɍĕ`s܂B
 * @return ƂtrueAsƂfalse
 * @note ̃r[͍ĕ`悵܂
 */
bool CFootyView::ScrollRefresh()
{
	if (m_bVisible)					// ĕ`͕\ĂƂ̂
	{
		// s\łȂ`FbN
		if (!m_cDoubleBuffering.IsRendered())
			return Refresh(false);
		
		// ǂ̂炢XN[ꂽׂ
		CEthicLine lnBeforeLast = *m_cDoubleBuffering.GetFirstVisible();
		lnBeforeLast.MoveEthicNext(m_pDocuments->GetLineList(),m_nVisibleLines);
		CEthicLine lnAfterLast = *m_pDocuments->GetFirstVisible(m_nViewID);
		lnAfterLast.MoveEthicNext(m_pDocuments->GetLineList(),m_nVisibleLines);

		int nScrolledNum = m_cDoubleBuffering.GetFirstVisible()->GetDifference
		(
			*m_pDocuments->GetFirstVisible(m_nViewID),
			m_pDocuments->GetLineList()
		);
		
		HDC hDC = m_cDoubleBuffering.GetDC();
		
		// SXN[Ă܂
		if (nScrolledNum == 0)
		{
			FOOTY2_PRINTF( L"not scrolled\n" );
			return true;
		}
		// փXN[ꂽƂ
		else if (0 < nScrolledNum && nScrolledNum < (int)m_nVisibleLines)
		{
			FOOTY2_PRINTF( L"scroll down\n" );
			CaretMove();
			SetBars();
			BitBlt(hDC,0,0,m_nWidth,m_nHeight,hDC,0,nScrolledNum * (m_pFonts->GetHeight() + m_nHeightMargin),SRCCOPY);
			RenderLines(lnBeforeLast.GetLinePointer(),lnAfterLast.GetLinePointer());
		}
		// փXN[ꂽƂ
		else if ((-(int)m_nVisibleLines) < nScrolledNum && nScrolledNum < 0)
		{
			FOOTY2_PRINTF( L"scroll up\n" );
			CaretMove();
			SetBars();
			BitBlt(hDC,0,0,m_nWidth,m_nHeight,hDC,0,nScrolledNum * (m_pFonts->GetHeight() + m_nHeightMargin),SRCCOPY);
			RenderLines(m_pDocuments->GetFirstVisible(m_nViewID)->GetLinePointer(),m_cDoubleBuffering.GetFirstVisible()->GetLinePointer());
		}
		// ʂ
		else
		{
			FOOTY2_PRINTF( L"scroll too much\n" );
			return Refresh(false);
		}
	}
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽsԂ݂̂ĕ`悷鏈Bw肳ꂽs͂ǂ炪łǂ炪ł܂܂B
 * @param pLine1 s1
 * @param pLine2 s2
 * @note ̃r[ĕ`悵܂B
 */
bool CFootyView::LineChangedRefresh(LinePt pLine1, LinePt pLine2)
{
	// JnsƏIs𒲂ׂ
	LinePt pStartLine = pLine1->GetRealLineNum() <  pLine2->GetRealLineNum() ? pLine1 : pLine2;
	LinePt pEndLine   = pLine1->GetRealLineNum() >= pLine2->GetRealLineNum() ? pLine1 : pLine2;

	// LbgʒuK؂Ȃ̂ɁBXN[o[͕ωȂc͂B
	CaretMove();

	// Sčĕ`
	for (int i=0;i<4;i++){
		if (m_pView[i].m_bVisible){
			m_pView[i].RenderLines(pStartLine, pEndLine);
		}
	}

	return true;
}


//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽsԂ݂̂ĕ`悷鏈
 * @param pStartLine Jns
 * @param pEndLine Is
 * @note ̃r[͍ĕ`悵܂B
 */
bool CFootyView::RenderLines(LinePt pStartLine,LinePt pEndLine)
{
	// 錾
	int yNowPos;									//!< ݕ`撆yWʒu
	CEthicLine cNowLine;							//!< ݕ`撆̍s\
	LineSize nLines = m_pDocuments->GetLineNum();	//!< ҏW̕Ɋ܂܂s̑
	SelOldInfo stOldInfo;							//!< Ï攽]̂߂̋foCXReLXg
	HDC hDcBuffer = m_cDoubleBuffering.GetDC();

	// 
	RECT rc;
	SetRect(&rc,0,0,m_nWidth,m_nHeight);
	m_cCaret.Hide();
	SetBkMode(hDcBuffer,TRANSPARENT);

	// ݂̕\ʒu烌_OĂ
	cNowLine = *m_pDocuments->GetFirstVisible(m_nViewID);
	yNowPos = m_nRulerHeight - (int)(cNowLine.GetEthicNum() *
		(m_nHeightMargin + m_pFonts->GetHeight()));
	forever{
		int yNext = yNowPos + (int)cNowLine.GetLinePointer()->GetEthicLine() * (m_nHeightMargin + m_pFonts->GetHeight());
	
		// _O
		if (pStartLine->GetRealLineNum() <= cNowLine.GetLineNum() &&
			cNowLine.GetLineNum() <= pEndLine->GetRealLineNum()){
			
			DrawRectangle(hDcBuffer,0,yNowPos,rc.right,yNext,m_pStatus->m_clBackGround);
			m_ImgCtr->Draw(hDcBuffer, 0, yNowPos, rc.right, yNext, m_cDoubleBuffering.GetWidth(), m_cDoubleBuffering.GetHeight() );
			RendLine(hDcBuffer,cNowLine.GetLinePointer(),yNowPos,cNowLine.GetLineNum() + 1 == nLines);
		}

		// yWύX
		yNowPos = yNext;
		if (yNowPos >= rc.bottom)break;

		// ̍s
		if (!cNowLine.MoveRealNext(m_pDocuments->GetLineList(),1))
			break;
	}
	DrawRectangle(hDcBuffer,0,yNowPos,rc.right,rc.bottom,m_pStatus->m_clBackGround);
	m_ImgCtr->Draw(hDcBuffer, 0, yNowPos, rc.right, rc.bottom, m_cDoubleBuffering.GetWidth(), m_cDoubleBuffering.GetHeight() );

	// Ï̔]
	if (m_pDocuments->IsSelecting()){
		// ̏
		cNowLine = *m_pDocuments->GetFirstVisible(m_nViewID);
		yNowPos = m_nRulerHeight - (int)(cNowLine.GetEthicNum() *
			(m_nHeightMargin + m_pFonts->GetHeight()));
		// [v̊Jn
		InitDcForSelect(hDcBuffer,&stOldInfo);
		forever{
			// Ï̔]
			if (pStartLine->GetRealLineNum() <= cNowLine.GetLineNum() &&
				cNowLine.GetLineNum() <= pEndLine->GetRealLineNum())
				RendSelected(hDcBuffer,&cNowLine,yNowPos);						 
			// WύX
			yNowPos += (int)((m_nHeightMargin + m_pFonts->GetHeight()) *
				cNowLine.GetLinePointer()->GetEthicLine());
			if (yNowPos >= rc.bottom)break;
			// ̍s
			if (!cNowLine.MoveRealNext(m_pDocuments->GetLineList(),1))
				break;
		}
		ReleaseDcForSelect(hDcBuffer,&stOldInfo);
	}

	// ̂قtp[c`
	RendLineCount(hDcBuffer,&rc);
	RendRuler(hDcBuffer,&rc);
	RendBorderLine(hDcBuffer,&rc);

	// [LOT[tBXRs[
	HDC hDC = GetDC( m_hWnd );
	FOOTY2_PRINTF( L"GetDC %d\n", m_nFootyID );
	BitBlt(hDC,0,0,m_nWidth,m_nHeight,hDcBuffer,0,0,SRCCOPY);
	m_cDoubleBuffering.SetRendInfo(m_pDocuments->GetFirstVisible(m_nViewID));
	RendUnderLine(hDC,&rc);
	ReleaseDC( m_hWnd, hDC );
	FOOTY2_PRINTF( L"ReleaseDC %d\n", m_nFootyID );

	// I
	m_cCaret.Show();
	return true;
}


//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽs̃f[^_O܂B
 * @param hDC `foCXReLXg
 * @param pLine `悷sf[^
 * @param x `xW
 * @param y `yW
 * @param bEnd ̍sŏIsł邩H
 */
bool CFootyView::RendLine(HDC hDC,LinePt pLine,int y,bool bEnd)
{
	if (!hDC)return false;

	//! `惂[h
	enum RendMode
	{
		RM_NORMAL,										//!< ʏ핶̃_O
		RM_URL,											//!< URL̃_O
		RM_MAIL,										//!< [̃_O
		RM_LABEL,										//!< x̃_O by Tetr@pod
		RM_FUNC,										//!< ߁E֐̃_O by Tetr@pod
	};
	
	/*錾*/
	size_t nSize = pLine->GetLineLength();				//!< ̒
	const wchar_t *pNowChar = pLine->GetLineData();		//!< ݕ`悵Ă镶
	int nColumn = 0;									//!< ݕ`悷ʒu
	CStaticStack<COLORREF,sizeof(int)*8+3> StackColor;	//!< `悷F̃X^bN
	RendMode nRendMode = RM_NORMAL;						//!< ݂̕`惂[h(m[}AURLA[AxA߁E֐)
	CFootyLine::CharSets nCharSets;
	int nStartUrl;										//!< URLA[AhXAxA߁E֐̊JnxW

	// p
	int nFirstVisCol = m_nFirstVisibleColumn;
	int nVisColms = (int)m_nVisibleColumns;
	int nNowEthicLine = 0;
	size_t nLapelColumn = m_pDocuments->GetLapelColumn();
	int nLapelMode = m_pDocuments->GetLapelMode();
	UrlIterator pNowUrl = pLine->GetUrlInfo()->begin();
	UrlIterator pEndUrl = pLine->GetUrlInfo()->end();
	UrlIterator pNowMail = pLine->GetMailInfo()->begin();
	UrlIterator pEndMail = pLine->GetMailInfo()->end();
	UrlIterator pNowLabel = pLine->GetLabelInfo()->begin();// by Tetr@pod
	UrlIterator pEndLabel = pLine->GetLabelInfo()->end();// by Tetr@pod
	UrlIterator pNowFunc = pLine->GetFuncInfo()->begin();// by Tetr@pod
	UrlIterator pEndFunc = pLine->GetFuncInfo()->end();// by Tetr@pod

	// _Ô߂̏
	SetTextColor(hDC,m_pStatus->m_clDefaultLetter);
	StackColor.push(m_pStatus->m_clDefaultLetter);
	
	// URLA[Axp̃y쐬
	HPEN hPenURL,hPenMail,hPenLabel;// hPenLabel by Tetr@pod
#ifdef UNDER_CE
	hPenMail = CreatePen(PS_SOLID,1,m_pStatus->m_clMailUnder);
	hPenURL = CreatePen(PS_SOLID,1,m_pStatus->m_clUrlUnder);
	hPenLabel = CreatePen(PS_SOLID,1,m_pStatus->m_clLabelUnder);// by Tetr@pod
#else	/*UNDER_CE*/
	hPenMail = CreatePen(PS_DOT,1,m_pStatus->m_clMailUnder);
	hPenURL = CreatePen(PS_DOT,1,m_pStatus->m_clUrlUnder);
	hPenLabel = CreatePen(PS_DOT,1,m_pStatus->m_clLabelUnder);// by Tetr@pod
#endif	/*UNDER_CE*/

	// LbV邩mFĂ
	if (!pLine->EmphasisChached())
		m_pDocuments->SetChacheCommand(pLine);
	std::vector<CFootyLine::EmpPos>::iterator pNowCommand = pLine->GetColorInfo()->begin();
	std::vector<CFootyLine::EmpPos>::iterator pEndCommand = pLine->GetColorInfo()->end();

	// Ps̃f[^_O
	for (size_t i=0;i<nSize;i++,pNowChar++){
		// ߁E֐H by Tetr@pod
		if (pNowFunc != pEndFunc){
			if (pNowFunc->m_nStartPos == i){
				nRendMode = RM_FUNC;
				switch (pNowFunc->m_nKind){
				case 0:
					SetTextColor(hDC,m_pStatus->m_clFunc1);
					break;
				case 1:
					SetTextColor(hDC,m_pStatus->m_clFunc2);
					break;
				case 2:
					SetTextColor(hDC,m_pStatus->m_clFunc3);
					break;
				case 3:
					SetTextColor(hDC,m_pStatus->m_clFunc4);
					break;
				case 4:
					SetTextColor(hDC,m_pStatus->m_clFunc5);
					break;
				case 5:
					SetTextColor(hDC,m_pStatus->m_clFunc6);
					break;
				case 6:
					SetTextColor(hDC,m_pStatus->m_clFunc7);
					break;
				case 7:
					SetTextColor(hDC,m_pStatus->m_clFunc8);
					break;
				}
				nStartUrl = GetTextPosX(nColumn);
			}
			if (pNowFunc->m_nEndPos == i){
				nRendMode = RM_NORMAL;
				SetTextColor(hDC,StackColor.top());
				pNowFunc++;
			}
		}
		// xH by Tetr@pod
		if (pNowLabel != pEndLabel){
			if (nRendMode != RM_FUNC){									// Ƃ肠߁E֐DA쓮h~
				if (pNowLabel->m_nStartPos == i){
					nRendMode = RM_LABEL;
					SetTextColor(hDC,m_pStatus->m_clLabel);
					nStartUrl = GetTextPosX(nColumn);
				}
				if (pNowLabel->m_nEndPos == i){
					nRendMode = RM_NORMAL;
					SetTextColor(hDC,StackColor.top());
					pNowLabel++;
					// A_[C̕`
					SelectObject(hDC,hPenLabel);
					MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
					LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
				}
			}
		}
		// URLH
		if (pNowUrl != pEndUrl){
			if (nRendMode != RM_LABEL && nRendMode != RM_FUNC){									// URL胉xA߁E֐D
				if (pNowUrl->m_nStartPos == i){
					nRendMode = RM_URL;
					SetTextColor(hDC,m_pStatus->m_clUrl);
					nStartUrl = GetTextPosX(nColumn);
				}
			}
			if (pNowUrl->m_nEndPos == i){
				nRendMode = RM_NORMAL;
				SetTextColor(hDC,StackColor.top());
				pNowUrl++;
				// A_[C̕`
				SelectObject(hDC,hPenURL);
				MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
				LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
			}
		}
		// [AhXH
		if (pNowMail != pEndMail){
			if (nRendMode != RM_URL && nRendMode != RM_LABEL && nRendMode != RM_FUNC){			// [AhXURLAxA߁E֐D
				if (pNowMail->m_nStartPos == i){
					nRendMode = RM_MAIL;
					SetTextColor(hDC,m_pStatus->m_clMail);
					nStartUrl = GetTextPosX(nColumn);
				}
			}
			if (pNowMail->m_nEndPos == i){
				nRendMode = RM_NORMAL;
				SetTextColor(hDC,StackColor.top());
				pNowMail++;
				// A_[C̕`
				SelectObject(hDC,hPenMail);
				MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
				LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
			}
		}
		
		// ̈ʒũR}hX^bNɐς
		for (;pNowCommand != pEndCommand;pNowCommand++){
			if (pNowCommand->m_nPosition == i){			// ʒu
				if (pNowCommand->m_bIsStart){
					if (nRendMode == RM_NORMAL)
						SetTextColor(hDC,pNowCommand->m_Color);
					StackColor.push(pNowCommand->m_Color);
				}
				else{
					StackColor.pop();
					if (nRendMode == RM_NORMAL)
						SetTextColor(hDC,StackColor.top());
				}
			}
			else break;									// Ⴄʒu̎̓[v𔲂
		}
		// _O(`GA̒̂)
		if (*pNowChar == L'\t'){						// ^u
			if (nFirstVisCol <= nColumn && nColumn <= nFirstVisCol + (int)nVisColms && ((m_nMarkVisible & EDM_TAB) != 0)){
				SetTextColor(hDC,m_pStatus->m_clTab);
				m_pFonts->UseFont(hDC,FFM_ANSI_CHARSET);
				ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,L">",1,NULL);
				SetTextColor(hDC,StackColor.top());
			}
			for (nColumn++;;nColumn++){
				if (nColumn % m_pDocuments->GetTabLen() == 0)
					break;
			}
		}
		else{
			// ̕擾
			if (CFootyLine::IsSurrogateLead(*pNowChar))
				nCharSets = CFootyLine::GetCharSets(*pNowChar,*(pNowChar+1));
			else
				nCharSets = CFootyLine::GetCharSets(*pNowChar);
			// tHg̃Zbg
			if (nFirstVisCol - 1 <= nColumn && nColumn <= nFirstVisCol + (int)nVisColms){
				switch (nCharSets){
				case CFootyLine::CHARSETS_ANSI_ALPHABET:		// ANSI(At@xbg)
				case CFootyLine::CHARSETS_ANSI_NUMBER:			// ANSI()
				case CFootyLine::CHARSETS_ANSI_SYMBOL:			// ANSI(A_[o[L)
				case CFootyLine::CHARSETS_ANSI_UNDER:			// ANSIA_[o[)
					m_pFonts->UseFont(hDC,FFM_ANSI_CHARSET);
					break;
				case CFootyLine::CHARSETS_HIRAGANA:				// {(Ђ炪)
				case CFootyLine::CHARSETS_KATAKANA:				// {(J^Ji)
				case CFootyLine::CHARSETS_KATAKANA_HALF:		// {(pJ^Ji)					
				case CFootyLine::CHARSETS_FULL_ALPHABET:		// SpAt@xbg
				case CFootyLine::CHARSETS_FULL_NUMBER:			// Sp
				case CFootyLine::CHARSETS_AINU_EXTENSION:		// ACkpg
				case CFootyLine::CHARSETS_SYMBOLS:				// L
				case CFootyLine::CHARSETS_JP_NOBASHI:			// {̂΂
				case CFootyLine::CHARSETS_IPA_EXTENSION:		// IPAg
					m_pFonts->UseFont(hDC,FFM_SHIFTJIS_CHARSET);
					break;
				case CFootyLine::CHARSETS_KANJI:				// 
					m_pFonts->UseKanjiFont(hDC);
					break;
				case CFootyLine::CHARSETS_KOREA:				// ؍
					m_pFonts->UseFont(hDC,FFM_HANGUL_CHARSET);
					break;
				case CFootyLine::CHARSETS_LATIN:				// e
					
					break;
				case CFootyLine::CHARSETS_BALTIC:				// og
					m_pFonts->UseFont(hDC,FFM_BALTIC_CHARSET);
					break;
				case CFootyLine::CHARSETS_ARABIC:				// ArA
					m_pFonts->UseFont(hDC,FFM_ARABIC_CHARSET);
					break;
				case CFootyLine::CHARSETS_HEBREW:				// wuC
					m_pFonts->UseFont(hDC,FFM_HEBREW_CHARSET);
					break;
				case CFootyLine::CHARSETS_GREEK:				// MV
					m_pFonts->UseFont(hDC,FFM_GREEK_CHARSET);
					break;
				case CFootyLine::CHARSETS_CYRILLIC:				// L
					m_pFonts->UseFont(hDC,FFM_RUSSIAN_CHARSET);
					break;
				case CFootyLine::CHARSETS_VIETTNAMESE:			// xgi
					m_pFonts->UseFont(hDC,FFM_VIETNAMESE_CHARSET);
					break;
				case CFootyLine::CHARSETS_THAI:					// ^C
					m_pFonts->UseFont(hDC,FFM_THAI_CHARSET);
					break;
				default:
					m_pFonts->UseFont(hDC,FFM_ANSI_CHARSET);
					break;
				}

				// FZbg
				if (*pNowChar == L'@'){
					if ((m_nMarkVisible & EDM_FULL_SPACE) != 0){
						SetTextColor(hDC,m_pStatus->m_clNormalSpace);
						m_pFonts->UseFont(hDC,FFM_SHIFTJIS_CHARSET);
						ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,L"",1,NULL);
						SetTextColor(hDC,StackColor.top());
					}
				}
				else if (*pNowChar == L' '){
					if ((m_nMarkVisible & EDM_HALF_SPACE) != 0){
						SetTextColor(hDC,m_pStatus->m_clHalfSpace);
						m_pFonts->UseFont(hDC,FFM_ANSI_CHARSET);
						ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,L"`",1,NULL);
						SetTextColor(hDC,StackColor.top());
					}
				}
				else{
					// TQ[gyA𗘗p̕`揈
					if (CFootyLine::IsSurrogateLead(*pNowChar) && i != nSize - 1){
						ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,pNowChar,2,NULL);
						i++;pNowChar++;
					}
					// ʏ̕̕`揈
					else{
						//FOOTY2_PRINTF( L"Drawing %s\n", pNowChar );
						ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,pNowChar,1,NULL);
					}
				}
			}
			// `ʒu߂ĂāATQ[gyÂƂ̓|C^ړ
			else if (CFootyLine::IsSurrogateLead(*pNowChar)){
				i++;pNowChar++;
			}
			
			// xW𑝂₷
			if (CFootyLine::IsDualChar(nCharSets))
				nColumn += 2;
			else
				nColumn ++;
		}

		// ̈ʒu͕`悷ʒuIĂH
		if (pLine->GetEthicLine() == nNowEthicLine + 1 &&
			nFirstVisCol + (int)nVisColms + 1 < nColumn)
			break;

		// ̍sֈړ邩H
		if (pLine->IsGoNext(pNowChar,i,nColumn,nLapelColumn,nLapelMode)){
			// URLA_[Čn
			switch(nRendMode){
			case RM_URL:
				SelectObject(hDC,hPenURL);
				MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
				LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
				nStartUrl = GetTextPosX(0);
				break;
			case RM_MAIL:
				SelectObject(hDC,hPenMail);
				MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
				LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
				nStartUrl = GetTextPosX(0);
				break;
			case RM_LABEL:// by Tetr@pod
				SelectObject(hDC,hPenLabel);
				MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
				LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
				nStartUrl = GetTextPosX(0);
				break;
			}
			// ̍s
			nColumn = 0;
			nNowEthicLine++;
			y += m_pFonts->GetHeight() + m_nHeightMargin;
		}
	}

	// URLA_[Čn
	switch(nRendMode){
	case RM_URL:
		SelectObject(hDC,hPenURL);
		MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
		LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
		break;
	case RM_MAIL:
		SelectObject(hDC,hPenMail);
		MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
		LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
		break;
	case RM_LABEL:// by Tetr@pod
		SelectObject(hDC,hPenLabel);
		MoveToEx(hDC,nStartUrl,y+m_pFonts->GetHeight(),NULL);
		LineTo(hDC,GetTextPosX(nColumn),y+m_pFonts->GetHeight());
		break;
	}
	
	// s̃}[N`悷
	if (bEnd && ((m_nMarkVisible & EDM_EOF) != 0)){
		m_pFonts->UseFont(hDC,FFM_ANSI_CHARSET);
		SetTextColor(hDC,m_pStatus->m_clEOF);
		ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,L"[EOF]",5,NULL);
	}
	else if ((m_nMarkVisible & EDM_LINE) != 0){
		m_pFonts->UseFont(hDC,FFM_SHIFTJIS_CHARSET);
		SetTextColor(hDC,m_pStatus->m_clCrlf);
		ExtTextOutW(hDC,GetTextPosX(nColumn),y,0,NULL,L"",1,NULL);
	}
	
	// IuWFNgj
	DeleteObject(hPenURL);
	DeleteObject(hPenMail);
	DeleteObject(hPenLabel);// by Tetr@pod
	return true;
}

/*----------------------------------------------------------------
CFootyView::InitDcForSelect
Ï̕`̂߂ɃfoCXReLXgB
pSelInfoɂ͌̏i[邽߂̍\̂ւ̃|C^
----------------------------------------------------------------*/
bool CFootyView::InitDcForSelect(HDC hDC,SelOldInfo *pSelInfo){
	if (!hDC || !pSelInfo)return false;
	/*GDIIuWFNg̍쐬*/
	pSelInfo->m_hPen = CreatePen(PS_SOLID,1,RGB(255,255,255));
	pSelInfo->m_hBrush = CreateSolidBrush(RGB(255,255,255));
	/*foCXReLXgɑ΂đIs킹*/
	pSelInfo->m_hPenOld = (HPEN)SelectObject(hDC,pSelInfo->m_hPen);
	pSelInfo->m_hBrushOld = (HBRUSH)SelectObject(hDC,pSelInfo->m_hBrush);
	pSelInfo->m_nRopOld = SetROP2(hDC,m_nRop2);
	return true;
}

/*----------------------------------------------------------------
CFootyView::ReleaseDcForSelect
Ï`悪IĂяoAfoCXReLXg
߂߂̃[`BpSelInfoɂ͌ɏꂽ\̂ւ̃|C^
----------------------------------------------------------------*/
bool CFootyView::ReleaseDcForSelect(HDC hDC,CFootyView::SelOldInfo *pSelInfo){
	if (!hDC || !pSelInfo)return false;
	/*̕I*/
	SelectObject(hDC,pSelInfo->m_hPenOld);
	SelectObject(hDC,pSelInfo->m_hBrushOld);
	SetROP2(hDC,pSelInfo->m_nRopOld);
	/*IuWFNgj󂷂*/
	DeleteObject(pSelInfo->m_hPen);
	DeleteObject(pSelInfo->m_hBrush);
	return true;
}

/*----------------------------------------------------------------
CFootyView::RendSelected
IGA`悷鏈
----------------------------------------------------------------*/
bool CFootyView::RendSelected(HDC hDC,CEthicLine *pLine,int y){
	if (!hDC || !pLine)return false;
	/*錾*/
	size_t i;														//!< [vJE^
	bool bSelCrlf = false;											//!< sʒu𔽓]邩ǂ
	CEditPosition *pSelStartPos = m_pDocuments->GetSelStart();		//!< IJnʒu
	CEditPosition *pSelEndPos = m_pDocuments->GetSelEnd();			//!< IIʒu
	size_t nEthicLine = pLine->GetLinePointer()->GetEthicLine();	//!< ̍s̘_s̐
	size_t nSelStartPosition,nSelEndPosition;						//!< ̍sɂI
	CFootyLine::EthicInfo stSelStartInfo,stSelEndInfo;				//!< ̘_s
	int nRectangleStartX,nRectangleEndX;							//!< vZp
	
	/*JnΈʒuݒ肷*/
	if (*pLine > *pSelStartPos)
		nSelStartPosition = 0;
	else if (*pLine == *pSelStartPos)
		nSelStartPosition = pSelStartPos->GetPosition();
	else return true;
	
	if (*pLine == *pSelEndPos)
		nSelEndPosition = pSelEndPos->GetPosition();
	else if (*pLine < *pSelEndPos){
		nSelEndPosition = pLine->GetLinePointer()->GetLineLength();
		bSelCrlf = true;
	}
	else return true;

	/*[vp̃f[^𐶐*/
	stSelStartInfo = pLine->GetLinePointer()->CalcEthicLine(nSelStartPosition,
		m_pDocuments->GetLapelColumn(),
		m_pDocuments->GetTabLen(),m_pDocuments->GetLapelMode());
	stSelEndInfo = pLine->GetLinePointer()->CalcEthicLine(nSelEndPosition,
		m_pDocuments->GetLapelColumn(),
		m_pDocuments->GetTabLen(),
		m_pDocuments->GetLapelMode());
	nRectangleStartX = (int)(m_nLineCountWidth + 
		(stSelStartInfo.m_nEthicColumn - m_nFirstVisibleColumn) *
		(m_pFonts->GetWidth() + m_nWidthMargin));
	nRectangleEndX = (int)(m_nLineCountWidth +
		(stSelEndInfo.m_nEthicColumn - m_nFirstVisibleColumn) *
		(m_pFonts->GetWidth() + m_nWidthMargin));
	/*[vŉ񂵂đÏ𔽓]*/
	for (i=0;i<nEthicLine;i++){
		/*̘_s̏Ԃɂĕ*/
		if (i == stSelStartInfo.m_nEthicLine && i == stSelEndInfo.m_nEthicLine){
			Rectangle(hDC,nRectangleStartX,y,
				nRectangleEndX+(bSelCrlf ? m_pFonts->GetWidth()*2 : 0),
				y+m_pFonts->GetHeight()+m_nHeightMargin);
			break;
		}
		else if (i == stSelStartInfo.m_nEthicLine)
			Rectangle(hDC,nRectangleStartX,y,m_nWidth,
				y+m_pFonts->GetHeight()+m_nHeightMargin);
		else if (i == stSelEndInfo.m_nEthicLine){
			Rectangle(hDC,m_nLineCountWidth,y,
				nRectangleEndX+(bSelCrlf ? m_pFonts->GetWidth()*2 : 0),
				y+m_pFonts->GetHeight()+m_nHeightMargin);
			break;
		}
		else if (stSelStartInfo.m_nEthicLine < i && i < stSelEndInfo.m_nEthicLine)
			Rectangle(hDC,m_nLineCountWidth,y,m_nWidth,
				y+m_pFonts->GetHeight()+m_nHeightMargin);
		/*yW𒲐*/
		y += m_pFonts->GetHeight() + m_nHeightMargin;
	}
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief sԍ\̈`悷鏈łB
 * @param hDC `foCXReLXg
 * @param rc ``
 * @return `ɐƂtrue
 */
bool CFootyView::RendLineCount(HDC hDC,const RECT *rc){
	if (!hDC || !rc)return false;					// oCXReLXgs
	if (!m_nLineCountWidth)return true;				// `悷KvȂ

	// 錾
	const size_t TEMP_BUFFER = 20;					//!< obt@TCY
	wchar_t szTempBuf[TEMP_BUFFER + 1];				//!< `悷镶̈ꎞobt@
	CEthicLine cNowLine = *m_pDocuments->GetFirstVisible(m_nViewID); //!< `悵Ăʒu
	int nPosX,nPosY;								//!< eLXg`ʒu
	int nTextLen;									//!< `悷eLXg̒
	SIZE sizTextRender;								//!< `悷͈
	HDC hDcBitmap = CreateCompatibleDC(hDC);

	// `̂߂̏
	m_pFonts->UseFont(hDC,FFM_ANSI_CHARSET);
	SetTextColor(hDC,m_pStatus->m_clLineNum);
	
	// `GA
	DrawRectangle(hDC,0,m_nRulerHeight,m_nLineCountWidth,
				  rc->bottom,m_pStatus->m_clBackGround);	// sԍ\̈̏

	// ݂̍s̈ʒu
	if (m_bIsFocused){
		if (m_nRulerHeight <= m_cCaret.GetNowY() && m_cCaret.GetNowY() < m_nHeight)
			DrawRectangle(hDC,0,m_cCaret.GetNowY(),m_nLineCountWidth-m_nLineCountMargin,
				m_cCaret.GetNowY() + m_pFonts->GetHeight() + m_nHeightMargin,m_pStatus->m_clCaretLine);
	}

	// _OJn
	for (nPosY = m_nRulerHeight;nPosY < rc->bottom;nPosY += m_pFonts->GetHeight() + m_nHeightMargin ){
		// _Os
		if (!cNowLine.GetEthicNum()){				// sԍ͍ŏ̘_ŝƂ̂ݕ\
			// sԍ\
			FOOTY2SPRINTF(szTempBuf, TEMP_BUFFER, L"%d", cNowLine.GetLineNum()+1);
			nTextLen = (int)wcslen(szTempBuf);
			GetTextExtentPoint32W(hDC, szTempBuf, nTextLen, &sizTextRender);
			nPosX = m_nLineCountWidth - m_nLineCountMargin - 2 - sizTextRender.cx;
			ExtTextOutW(hDC,nPosX,nPosY,0,NULL,szTempBuf,nTextLen,NULL);

			// ACR\
			int nIconLeft = LINEICON_MARGIN;
			int nLineIcons = cNowLine.GetLinePointer()->GetLineIcons();
			for (int nIconIndex = 0;nLineIcons != 0 && nIconIndex < sizeof(int) * 8;nIconIndex++){
				if ((nLineIcons & (1 << nIconIndex)) != 0){
					int nIconTop = nPosY + ( m_pFonts->GetHeight() + m_nHeightMargin ) / 2 - ICON_HEIGHT / 2;
					SelectObject(hDcBitmap,m_bmpIcons[nIconIndex]);
					TransparentBlt(hDC,nIconLeft,nIconTop,ICON_WIDTH,ICON_HEIGHT,
						hDcBitmap,0,0,ICON_WIDTH,ICON_HEIGHT,RGB(255,0,255));
					nIconLeft += ICON_WIDTH + LINEICON_MARGIN;
				}
			}
		}
		// ̍s
		if (!cNowLine.MoveEthicNext(m_pDocuments->GetLineList(),1))
			break;									// ̍sɍsȂƂ͔
	}

	DeleteDC(hDcBitmap);
	return true;
}

/*----------------------------------------------------------------
CFootyView::RendBorderLine
sԍ\̈ƃGfB^̃{[_[C`悷鏈
----------------------------------------------------------------*/
bool CFootyView::RendBorderLine(HDC hDC,const RECT *rc){
	if (!hDC || !rc)return false;
	DrawLine(hDC,m_nLineCountWidth-m_nLineCountMargin,0,
		m_nLineCountWidth-m_nLineCountMargin,rc->bottom,m_pStatus->m_clLineNumLine);
	return true;
}

/*----------------------------------------------------------------
CFootyView::RendUnderLine
Lbg̃A_[C`悷郋[`
----------------------------------------------------------------*/
bool CFootyView::RendUnderLine(HDC hDC,const RECT *rc)
{
#ifndef UNDER_CE
	if (!hDC || !rc)return false;
	if (m_bUnderlineVisible && m_bIsFocused && !m_pDocuments->IsSelecting())
	{
		DrawLine(hDC,m_nLineCountWidth,m_cCaret.GetNowY() + m_pFonts->GetHeight() + 1,
				rc->right,m_cCaret.GetNowY() + m_pFonts->GetHeight() + 1,m_pStatus->m_clUnderLine);
	}
#endif	/*not defined UNDER_CE*/
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief sԍ\̈`悷鏈łB
 * @param hDC `foCXReLXg
 * @param rc ``
 * @return ƂtrueԂ
 */
bool CFootyView::RendRuler(HDC hDC,const RECT *rc)
{
	FOOTY2_ASSERT( hDC );
	FOOTY2_ASSERT( rc );
	
	// 錾
	size_t i;
	const size_t TEMP_BUFFER = 20;
	wchar_t szWork[TEMP_BUFFER + 1];
	int nPosX;

	// x[X`
	DrawRectangle(hDC,0,0,rc->right,m_nRulerHeight,m_pStatus->m_clRulerBk);	// [[wi`
	
	// [[߂̃IuWFNg
	HPEN hPen, hOldPen;
	hPen=CreatePen(PS_SOLID,1,m_pStatus->m_clRulerLine);	// [[̌r߂̃y
	SetTextColor(hDC,m_pStatus->m_clRulerText);				// [[̃eLXg̐F
	SetBkMode(hDC,TRANSPARENT);								// wi𓧂悤`
	m_pFonts->UseRulerFont(hDC);
	hOldPen=(HPEN)SelectObject(hDC,hPen);					// yZbg
    
	/*[[̃Lbĝӏ*/
	if (m_bIsFocused && m_nLineCountWidth <= m_cCaret.GetNowX() && m_cCaret.GetNowX() < m_nWidth)
		DrawRectangle(hDC,m_cCaret.GetNowX(),0,m_cCaret.GetNowX()+m_pFonts->GetWidth(),
			m_nRulerHeight,m_pStatus->m_clCaretPos);

	/*C̕`ʂ*/
	int nFontWidth = m_pFonts->GetWidth();				// p
	int nRulerHeight = m_nRulerHeight;					// p
	int nOtherStartY = nRulerHeight*8/9;				// p
	int nHalfStartY = nRulerHeight >> 1;				// p
	int nFirstVisibleCol = m_nFirstVisibleColumn;		// p
	size_t nLapelCol = m_pDocuments->GetLapelColumn();	// p
	size_t nVisibleCol = m_nVisibleColumns;				// p
	for (i=m_nFirstVisibleColumn,nPosX=m_nLineCountWidth;;i++,nPosX+=nFontWidth)
	{
		// C̕`
		if (i % 10 == 0)			// 10̔{(傫ȃo[)
		{
			MoveToEx(hDC,nPosX,0,NULL);
			LineTo(hDC,nPosX,nRulerHeight);
			FOOTY2SPRINTF(szWork, TEMP_BUFFER, L"%d", i);
			ExtTextOutW(hDC,nPosX+2,nRulerHeight-
				m_pFonts->GetRulerHeight(),0,NULL,szWork,(int)wcslen(szWork),NULL);
		}
		else if (i % 5 == 0)		// 5̔{(炢̃o[)
		{
			MoveToEx(hDC,nPosX,nHalfStartY,NULL);
			LineTo(hDC,nPosX,nRulerHeight);
		}
		else						// ȃo[
		{
			MoveToEx(hDC,nPosX,nOtherStartY,NULL);
			LineTo(hDC,nPosX,nRulerHeight);
		}
		// [v𔲂
		if (i >= nFirstVisibleCol + nVisibleCol + 2)break;
		if (i == nLapelCol)break;
	}

	// [[pIuWFNg̊J
	SelectObject(hDC,hOldPen);
	DeleteObject(hPen);
	return true;
}


/*----------------------------------------------------------------
CFootyView::DrawRectangle
w肳ꂽfoCXReLXgnhɁA``ʂ܂B
̒`́AghԂ܂B
----------------------------------------------------------------*/
void CFootyView::DrawRectangle(HDC hDC,int x1,int y1,int x2,int y2,COLORREF color)
{
	HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;
	
	hPen = (HPEN)CreatePen(PS_SOLID, 1, color);
	hOldPen = (HPEN)SelectObject(hDC, hPen);
	hBrush = (HBRUSH)CreateSolidBrush(color);
	hOldBrush = (HBRUSH)SelectObject(hDC, hBrush);

	Rectangle(hDC, x1, y1, x2, y2);

	SelectObject(hDC,hOldPen);
	SelectObject(hDC,hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
}

/*----------------------------------------------------------------
CFooty::DrawLine
<>
hDC         `foCXReLXg
x1,y1,x2,y2 `W
color       F
<>
w肳ꂽfoCXReLXgnhɁA܂B
͎ɂȂ܂B
----------------------------------------------------------------*/
void CFootyView::DrawLine(HDC hDC,int x1,int y1,int x2,int y2,COLORREF color,int penType)
{
	HPEN hPen,hOldPen;
	hPen = (HPEN)CreatePen(penType,1,color);
	hOldPen = (HPEN)SelectObject(hDC, hPen);
	MoveToEx(hDC,x1,y1,NULL);
	LineTo(hDC,x2,y2);
	SelectObject(hDC,hOldPen);
	DeleteObject(hPen);
}

void CFootyView::SetUnderlineDraw(bool flag){
	m_bUnderlineDraw = flag;
	//m_bUnderlineDraw = true;
}

BOOL CFootyView::ImageLoad(const wchar_t *pFilePath){
	return m_ImgCtr->Load(pFilePath);
}
void CFootyView::ImageClear(void){
	m_ImgCtr->UnLoad();
}
void CFootyView::SetColor(COLORREF color){
	m_ImgCtr->SetBgColor(color);
}

/*[EOF]*/
